#!/usr/bin/perl -w
use XML::Dumper;
use strict;
use Digest::MD5;

#print randomPassword(); exit 0;
my $realm = "ab";
my %access = (
    ab    => { password => 'quality',restriction => '.+' },
    pig   => { password => 'quality',restriction => 'Pig'},
    three => { password => 'quality',restriction => 'Pennellii|AllRound|F5'},
    heinz => { password => 'quality',restriction => 'Heinz'}
);

#htpasswd -cb .htpasswd ab quality
#htpasswd -b  .htpasswd heinz quality

my %rest;
my $uc = 0;
open HT, ">.htpasswd" or die "$!";
foreach my $user ( sort keys %access ) {
    my $data = $access{$user};
    my $pass = $data->{password};
    my $rest = $data->{restriction};
    $rest{$user} = $rest;
    #print `htpasswd -b$c .htpasswd $user $pass`;
    #print `htdigest -b$c .htpasswd $realm $user $pass`;
    print HT "$user:$realm:" . Digest::MD5::md5_hex("$user:$realm:$pass") . "\n";
    print    "$user:$realm:" . Digest::MD5::md5_hex("$user:$realm:$pass") . "\n";
}
close HT;

my $output = "access.xml";
my $dump   = new XML::Dumper;
$dump->dtd;
$dump->pl2xml(\%rest, $output);







sub randomPassword {
    my $password;
    my $_rand;

    my $password_length = $_[0];
    if (!$password_length) {
        $password_length = 6;
    }

    my @chars = split(" ",
    "a b c d e f g h i j k l m n o p q r s t u v w x y z
     A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
     - _ \% \# \| 0 1 2 3 4 5 6 7 8 9");
#    print join("\n", @chars);

    srand;

    for (my $i=0; $i <= $password_length ;$i++) {
        $_rand = int(rand scalar @chars);
        $password .= $chars[$_rand];
    }
    return $password;
}
